#!/usr/bin/perl -w
#
# creator.cgi
#
# Script to allow users to create a basic web page.
# Present simple dialog and prepare the web page.
# Sends data to makepage.cgi.
#
# Copyright 1998 Corel Computer Corporation
#
# This is open-source software (see www.opensource.org).  Open Source(R)
# is a Registered Certification Mark of Software in the Public Interest.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 1,
# or, (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to the
# Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


use strict;
use CGI;
use CGI::Carp "fatalsToBrowser";
require '../layout.pl';

# Define some colors to use in page creation.
my @colors = qw/White Black Silver Gray Maroon Red Purple Fuchsia Green
                Lime Olive Yellow Navy Blue Teal Aqua/;

# Check who the user is
die "Username unknown.  Cannot continue.\n"
unless defined $ENV{'REMOTE_USER'};
my $wfuser = $ENV{'REMOTE_USER'};

my @user = getpwnam($wfuser);
my $group = getgrgid($user[3]);
my $def_title = "Welcome to ".$wfuser."'s homepage";


### Read in any existing defaults from the users .htmlrc file

my $q;
if (-r "/home/$wfuser/.htmlrc") {
  open FH, "/home/$wfuser/.htmlrc" or die "Can't read .htmlrc\n";
    $q = new CGI('FH');
  close FH;
} else {
  $q = new CGI("");
}


### Output section:

print start_webfront("Web Page Creator","user",2,1).

#  $q->img({-src=>"/images/user/userdiaban.jpg"}).

  $q->start_form('post',"/cgi-bin/corel/account/makepage.cgi").

  $q->table({-border=>0,-width=>560,-bgcolor=>'white',-cellpadding=>'1'},
    $q->Tr({-bgcolor=>'white'}, 
      $q->td({-colspan=>'2'},
        $q->img({-src=>"/images/user/userdiaban.jpg"}))).

    $q->Tr({-bgcolor=>'#E4E4E4'},
      $q->td({-nowrap=>1},"Enter a title for your page"),
      $q->td($q->textfield(-name=>"title",-default=>$def_title,-size=>30))).
    $q->Tr({-bgcolor=>'#E4E4E4'},
      $q->td("Select your text color"),
      $q->td($q->popup_menu(-name=>'text',
         		    -Values=>\@colors,
			    -default=>'Black'))) .
    $q->Tr({-bgcolor=>'#E4E4E4'},
      $q->td("Select your background color"),
      $q->td($q->popup_menu(-name=>'background',
    	                    -Values=>\@colors,
       	                    -default=>'White'))) .
    $q->Tr({-bgcolor=>'#E4E4E4',-align=>'center'},
      $q->td({-colspan=>'2'},"Enter any comments for you page below")).
    $q->Tr({-bgcolor=>'#E4E4E4',-align=>'center'},
      $q->td({-colspan=>'2'},
        $q->textarea(-name=>'comments',
    	              -value=>"Thanks for visiting",
	              -rows=>'10',-cols=>'50',
	              -wrap=>'physical')))).

  $q->submit("save"). 
  $q->reset("reset"). 
  $q->end_form().

  end_webfront();
