#!/usr/bin/perl -wT
#
# account/makepage.cgi
#
# Actual script to write/store users web page.  Receives input
# from a form created by creator.cgi.
#
# Copyright 1998 Corel Computer Corporation
#
# This is open-source software (see www.opensource.org).  Open Source(R)
# is a Registered Certification Mark of Software in the Public Interest.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 1,
# or, (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to the
# Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

use strict;
use CGI;
use CGI::Carp "fatalsToBrowser";
require '../layout.pl';
require '../common.pl';

BEGIN { $ENV{'PATH'} = '/bin:/usr/bin'; }

die "Username unknown.  Cannot continue.\n"
unless defined $ENV{'REMOTE_USER'};
my $wfuser = $ENV{'REMOTE_USER'};

# Untaint the user name now.
$wfuser =~ /([-._a-zA-Z0-9]+)/;
my $user = $1;

# Retrieve CGI parameters
my $q = new CGI;
my $title = $q->param('title') || 'Default title';
my $text = $q->param('text') || 'black';
my $back = $q->param('background') || 'white';
my $comm = $q->param('comments') || 'This is a default web page.';

# Save the raw query data for later
umask(022);
open FH, ">/home/$user/.htmlrc" or die "Can't write htmlrc\n";
  $q->save('FH');
close FH;

# Save actual HTML web page now
my $htmldir = publish_dir_name();
$htmldir =~ /(.+)/;
my $html = $1;

open FH, ">/home/$user/$html/index.html" 
  or die "Can't write index.html\n";
  print FH $q->start_html(-title=>$title,
                          -bgcolor=>$back,
                          -text=>$text);
  print FH $q->h1({-align=>'center'},$title);
  print FH $q->p($comm);
  print FH $q->end_html();
close FH;

### Now print out confirmation message.

my $host = host();

print start_webfront("Web Page Creator","user",2,1).

  $q->h1("Web page created.").
  $q->p("Click <A HREF=\"http://$host/~$user\" TARGET=\"_top\">here</A>".
          " to view your page.").

  end_webfront();
