#!/usr/bin/perl -w
#
# admin/gmain.cgi
#
# Display list of users on system, with edit/remove buttons.
#
# Copyright 1998 Corel Computer Corporation
#
# This is open-source software (see www.opensource.org).  Open Source(R)
# is a Registered Certification Mark of Software in the Public Interest.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 1,
# or, (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to the
# Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

use strict;
use CGI;
use CGI::Carp "fatalsToBrowser";
require '../layout.pl';
require '../common.pl';

# Ensure that a known user is accessing the service

die "Username unknown.  Cannot continue.\n"
unless defined $ENV{'REMOTE_USER'};

# Fetch the CGI parameters, if any

my $q = new CGI;
my $newgroup = 0;
my @group = ('','','','');
my @members = ();
my $memberlist;

# Get a list of groups on the system
my %system_groups = read_group();

if ( $q->param('who') eq '' ) #add a new group
{
  $newgroup = 1;
}

my $groupstring;
if ( $newgroup eq 0 )
{
  $group[0] = $q->param('who');
  my $groupline = $system_groups{ $group[0] };
  $group[1] = $$groupline[1];
  $group[2] = $$groupline[2];
  $group[3] = $$groupline[3];
  @members = split(/,/, $group[3]); 

  #Make a title bar
  $memberlist = CGI::Tr({-bgcolor=>'navy'},
                CGI::td(CGI::font({-face=>'Arial',-size=>'2',-color=>'white'},
                CGI::b('Username'))),
                CGI::td({-align=>'center'},
                CGI::font({-face=>'Arial',-size=>'2',-color=>'white'},
                CGI::b('Action'))));
  #Draw a list of members with remove buttons
  for ( my $counter = 0 ; $counter <= $#members; $counter++)
  {
    $memberlist .= CGI::Tr({-valign=>'middle',-bgcolor=>'E4E4E4'},
                   CGI::td($members[$counter]),
                   CGI::td({-align=>'center', -valign=>'middle'},
    qq(<A HREF=/cgi-bin/corel/admin/gmod.cgi?group=$group[0]&user=$members[$counter]&status=remove>Remove User</A>)));
  }
  if ( $#members eq -1 )
  {
    $memberlist .= CGI::Tr({-valign=>'middle',-bgcolor=>'#E4E4E4'},
                   CGI::td('Currently no members'), 
                   CGI::td('&nbsp;'));
  }

  # Read in the passwd file and generate a userlist
  my %userfile = read_passwd() ;
  my @userlist = ();
  my @systemusers = sort( keys %userfile );  
  
  # Hack out users already in the group
  for ( my $counter = 0 ; $counter <= $#systemusers ; $counter++)
  {
    if ( is_member( $systemusers[$counter], $group[0]  ) ne 1 )
    {
      $userlist[$#userlist + 1] = $systemusers[$counter] ;
    }
  }
#  $userlist[$#userlist + 1 ] = 'none' ;

  # Bring up the userlist in a popup for user adding
  $memberlist .= CGI::Tr({-valign=>'middle',-bgcolor=>'#E4E4E4'},
                 CGI::td(CGI::scrolling_list(-name=>'user',
                                         -Values=>\@userlist,
					 -multiple=>1,
                                         -default=>'')),
                 CGI::td({-align=>'center'}, 
                     'Select the users to add to this group'));
  $groupstring = qq(<TR BGCOLOR="#E4E4E4"><TD WIDTH="50%">Group Name</TD>
		    <TD WIDTH="50%">$group[0]</TD></TR>
                    <INPUT TYPE="hidden" NAME="group" VALUE="$group[0]">);
}
else
  {
  $group[2] = find_free_gid();
  $groupstring = qq(<TR BGCOLOR="#E4E4E4"><TD WIDTH = "50%"">Group name</TD>
                   <TD WIDTH="50%"><INPUT NAME="group">
                   </TD></TR>);
  }


print start_webfront("Edit group","admin",4,-1);

print $q->start_form(-method=>'post',
                     -action=>'/cgi-bin/corel/admin/gmod.cgi');
print '<IMG SRC="/images/admin/userdiaban.jpg" ALIGN="center" VALIGN="top"><BR>';
print $q->table({-border=>0,-width=>560,-bgcolor=>'white',-cellpadding=>'1'},
        $q->i("$groupstring"),
        $q->hidden(-name=>'newgroup',-value=>"$newgroup"),
        $q->hidden(-name=>'gid',-value=>"$group[2]"),
	$q->Tr({-bgcolor=>'#E4E4E4'},
	  $q->td({-width=>'50%'},'Group ID') . $q->td({-width=>'50%'},"$group[2]")),
        $q->i($memberlist),
 );

if ( $newgroup eq 0 )
{
  print $q->input({-type=>'submit',-value=>'Make the changes'});
}
else
{ 
  print $q->input({-type=>'submit',-value=>'Add this group'});
}

print end_webfront();
