#!/usr/bin/perl -wT
#
# admin/udel.cgi
#
# Remove a user from the system
#
# Copyright 1998 Corel Computer Corporation
#
# This is open-source software (see www.opensource.org).  Open Source(R)
# is a Registered Certification Mark of Software in the Public Interest.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 1,
# or, (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to the
# Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

require '../layout.pl';
use CGI;
use CGI::Carp qw/fatalsToBrowser/;
BEGIN { $ENV{'PATH'} = '/bin:/usr/bin'; }
# Check who the user is
my @errors ;

push @errors, "Remote username could not be determined."
unless defined $ENV{'REMOTE_USER'};

my @user = getpwnam($ENV{'REMOTE_USER'}) or
push @errors, "User is not authorized for this service.";

push @errors, "You must enter a real name."
unless defined CGI::param('who') and CGI::param('who') ne '';

push @errors, "You cannot delete the administrative user."
unless CGI::param('who') ne 'httpd' ;

# Check for errors, abort if any found.

if (@errors) {
  print start_webfront("Confirmation","admin",3,-1);
  print CGI::h1((($#errors > 0) ? "Errors have" : "An error has")." been detected");
  print CGI::ul(CGI::li(\@errors));
  print CGI::p(CGI::i('Go <A HREF="userlist.cgi">back</A> and try again.'));
  print end_webfront();
  exit(1);
}

# Remove user from etc/passwd 
my $string = CGI::param('who');
my $passwd = "/etc/passwd";
my $tmpfile = "tmpfile.txt";
my $groupfile = "/etc/group";
open (IN, $passwd) or die "Can't open /etc/password\n" ;
open (OUT, ">$tmpfile") or die "Can't create tempfile\n" ;
while (<IN>){
	my $line = $_ ;
	my @fields = split (":", $line);
	if ("$fields[0]" ne "$string"){
		print OUT $line;
	}else {
                if ( $fields[5] =~ /^(\/\bhome\b\/[-a-zA-Z0-9]*)$/ )
		{
			system("rm", "-rf",$1);
		}
		else 
		{
		die "Illegal characters in $fields[5]" ;
		}
	}
}
close IN;
close OUT;
system ("cp",$tmpfile, $passwd);
system ("rm",$tmpfile);

# update web server password file
system "/usr/bin/htpasswd.sh";

#Remove user from etc/group
open (IN,$groupfile);
open (OUT,">$tmpfile");
while (<IN>){
	my $line = $_ ;
	chomp $line;
	@fields = split (":", $line);
	my @groups = ();
	@groups = split (",", $fields[3]) 
	if defined $fields[3] ;
	my @members = ();
        for (my $count = 0 ; $count <= $#groups ; $count++)
	{
		if ($groups[$count] ne $string)
		{
			$members[$#members+1] = $groups[$count] ;
		}
	}
	$fields[3] = join (",", @members) ;
	print OUT "$fields[0]:$fields[1]:$fields[2]:$fields[3]\n";
}
close OUT;
close IN;
system("cp", $tmpfile, $groupfile);
system("rm", $tmpfile);
print start_webfront("Confirmation","admin",3,-1);
print CGI::h1("Operation was successful.");
print CGI::p('Click <A HREF="userlist.cgi">here</A> to return.');
print end_webfront();                 
