#!/usr/bin/perl -w
#
# admin/userlist.cgi
#
# Display a list of users on the system.
#
# Copyright 1998 Corel Computer Corporation
#
# This is open-source software (see www.opensource.org).  Open Source(R)
# is a Registered Certification Mark of Software in the Public Interest.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 1,
# or, (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to the
# Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

use CGI;
use strict;
require '../layout.pl';

# Read password file
my @users;
open FH, "/etc/passwd" or die "Unable to read password file\n";
while (<FH>) {
  chomp;
  my @user = split /:/;
  if ($user[2] >= 100) {
    $user[4] =~ s/,.*//;
    $user[4] = $user[4] || $user[0];
    push @users, [@user];
  }
}
close FH;

my $q = new CGI;
my $hostname = `hostname -f`;
$hostname =~ s/[ \n\r]//g;

my $userlist;

map { $userlist .= qq(
 <tr bgcolor="#E4E4E4">
  <td align="CENTER" valign="MIDDLE">$$_[4]</td>
  <td align="CENTER" valign="MIDDLE">$$_[0]</td>
  <td align="CENTER" valign="MIDDLE">
    <A HREF="/cgi-bin/corel/admin/umain.cgi?who=$$_[0]">Edit</A>&nbsp;&nbsp;
    <A HREF="/cgi-bin/corel/admin/confirm_udel.cgi?who=$$_[0]">Remove<A></td>
 </tr>) . "\n" } @users;


print start_webfront("List of Users","admin",0,0);

print <<EOF;
<table width="560" border="0" align="LEFT" valign="TOP" bgcolor="white">
 <TR BGCOLOR="WHITE">
  <td width="560" height="36" colspan="3" align="CENTER" valign="TOP">
   <IMG SRC="/images/admin/userdiaban.jpg"></td>
 </tr>
    <tr align="CENTER" valign="MIDDLE" bgcolor="NAVY">
      <td><font face="Arial" size="2" color="White"><b>Full Name</b></font></td>
      <td><font face="Arial" size="2" color="White"><b>Login Name</b></font></td>
      <td><font face="Arial" size="2" color="White"><b>Options</b></font></td>
    </tr>
    $userlist
  </table>
EOF

print end_webfront(); 
